%% script for SLOC canonical paths (short version, see cpdemo1D_full for more)
%% Cell 1: CP from p3/pt19 to f1/pt13; natural continuation
p=[]; p=ocinit(p,'p3','pt19','f1','pt13'); % set standard options, also set
% p3/pt19 as start and f1/pt13 as end point of the canonical path
% set oc-params for which there is no default: 
p.ocopt.rhoi=1; % index of discount rate rho, rho is at p.u(p.nu+p.nq+rhoi)
p.ocopt.T=100; % truncation time
% reset some oc-params to customized values 
p.ocopt.nti=41; % initial # of points in t-mesh 
p.ocopt.msw=1; % use secant predictors (after first step) in iscnat 
% continuation call
alvin=[0.25 0.5 0.7 1]; % desired alpha-values; these can also be split, 
% e.g., first call isc with alvin=[0.25 0.5], then again with alvin=[0.7 1]  
p=isc(p,alvin); % continuation call
% plotting
%%
va=[15,30]; slsolplot_NT(p,va); % some plots 
%% Cell 2: a fold in alpha, arclength contiuation is needed, initial call
p=[]; p=ocinit(p,'p1','pt68','f1','pt13');
p.ocopt.rhoi=1; p.ocopt.nti=41; p.ocopt.T=100;
opt.nsteps=3; % # of steps for iscarc 
p.ocopt.sig=0.1;  p.ocopt.sigmax=1; % stepsize and max stepsize 
p.tomopt.Stats_step='on'; % give mtom diagnostics 
p.ocopt.retsw=1; % return full alpha and soln history 
alvin=[0.2 0.3]; % alpha values for startup of iscarc
p=iscT(p,alvin,3); % continuation call 
%% Cell 3: subsequent arclength-continuation-calls (repeat this cell to continue further) 
p=iscT(p,[],30);  
% For Skibademo Cell 2+3 have to be run to have p in workspace, or save p
% here and load in Skibademo
% save('skibap.mat','p');
%% Cell 4: fix al from arc cont to some given value and compute CP
% The al value closest to the desired has been picked from the history,
% checked via p.hist.alpha
p.cp.u=p.hist.u{end-2}; p.cp.t=p.hist.tt{end-2};
p.cp.par=p.hist.par{end-2}; % extract sol from history
p=iscT(p,0.6); % "continuation" call to compute the desired al value
v=[100,30]; slsolplot_NT(p,va); % some plots
%% Cell 5: again a canonical path from p3/pt19 to f1/pt13
% now with automatic truncation time adaption and the basic solver cpbvpnew
% setup as in Cell 1
p=[];p=ocinit(p,'p3','pt19','f1','pt13'); p.ocopt.rhoi=1; p.ocopt.nti=41; p.ocopt.msw=1;
p.ocopt.mtom=0; % switch to newtom solver
%p.tomopt.Nmax=200; % if mtom is used, more mesh points are necessary
p.ocopt.derr=1e-6; % max derivation from CSS
p.ocopt.T=22; % reduce truncation time to trigger adaption
% continuation call
alvin=(1e-2:5e-2:1).^2; % desired alpha-values;
% these can also be split, e.g., first call isc with alvin=[0.25 0.5], then again with alvin=[0.7 1]  
p=iscT(p,alvin); % continuation call
%% Cell 6: a simple plot of J over alpha, call after Cell 3
figure(6); clf;
plot(p.hist.alpha(1,:),p.hist.vv(1,:),'-*');
set(gca,'FontSize',14); xlabel('\alpha','FontSize',14); ylabel('J_{a}','FontSize',14);
%% Cell 7: some further plots, call i.e. after cell 3
va=[25,15]; slsolplot_NT(p,va); % some further plots